
/*
 * DEFS.H
 *
 *	(C)Copyright 1987 by Matthew Dillon, All Rights Reserved
 *
 */

#include <exec/types.h>
#include <exec/io.h>
#include <devices/keymap.h>
#include <devices/console.h>
#include <exec/memory.h>
#include <intuition/intuition.h>
#include <typedefs.h>
#include "xmisc.h"

#define MAXTOGGLE   256
#define QMOVE	    0x6B

#define COLT(n)  (XTbase + (n) * Xsize)
#define ROWT(n)  (YTbase + (n) * Ysize)
#define COL(n)	 (Xbase  + (n) * Xsize)
#define ROW(n)	 (Ybase  + (n) * Ysize)

typedef unsigned char u_char;
typedef struct WBStartup  WBS;
typedef struct DiskObject DISKOBJ;

extern WBS	*Wbs;
extern DISKOBJ	*Do;

extern short Xsize, Ysize;
extern short XTbase, YTbase;
extern short Rows, Columns;
extern short Xbase, Ybase;
extern short Xpixs, Ypixs;
extern u_char *av[];
extern char Wdisable;


typedef struct _ED {
    struct _ED *next, **prev;
    WIN *Win;
    long Topline, Topcolumn;
    long Line, Column;
    long Lines, Maxlines;
    u_char **List;
    u_char Name[64];
    u_char Wtitle[130];
    char Modified;
    u_char Tabstop;
    u_char Margin;
    char Insertmode;
    char Wordwrap;
    char iconmode;	    /* window in icon mode		    */
    short Winx, Winy, Winwidth, Winheight;
    short IWinx, IWiny;
    long BSline, BEline;    /* block start and end lines	    */
    short BSchar, BEchar;   /* char start on BSline, end on BEline  */
    long dirlock;	    /* directory lock			    */
} ED;


#ifndef NULL
#define NULL 0
#endif
#ifdef E
#undef E
#endif

extern ED E, *Ep, *Base;
extern char Savetabs, titleupdate;
extern char memoryfail, Nsu;
extern u_char Current[256];
extern short Clen;
extern char  Abortcommand, MShowTitle;
extern short ComLineMode;
extern RP *Rp;
extern WIN *Win;

extern u_char *MAllocate();
extern u_char *AllocMem(), *strcpy(), *malloc();
extern char *keyspectomacro();

extern void search_operation();



